#
#  RAID device info
#  MD1000 Shelves - 25 PD on each
#  2 Perc6/e Controllers, 2 4x SAS ports per card, one MD1000 per port
#
#  mfid0 - RAID6 using 60 PD on 1 controller
#  mfid1 - internal Perc5/i RAID1 system disk
#  mfid2 - same 
#  128KB stripe width, write-back, read-ahead (unless noted in specific tests)
#
#  someday should use /usr/local/sbin/megarc to do what I did manually
#  eh...util not seeing our Perc6 LSI megaraid...why?
#
#  this test is a bit different than before
#  per Wenjing's advice to make it go faster
#  I have limited max system memory to 300M
#  also according to her advice I have setup the script to write a file 40 times larger 
#  system RAM. 
#  results should still be comparable

### update 05-22-2008
# test 5 of iozone is same as test 4 but using the full system memory.  
# iozone_umfs11_fbsd.pl was modified to use 2 * system memory instead of 40* as when
# we were using limited memory before
# see end of file for test 5 initialization   


# run 1 
# gstripe label -v test /dev/mfid0 /dev/mfid2
#soft updates, rest are defaults.  No journal.
# newfs -U /dev/stripe/test



# # run 2
# geom stripe creation - stripe equal to hardware stripe width
#gstripe label -v -s 128k  test /dev/mfid0 /dev/mfid2 
# soft updates, rest are defaults.  No journal. 
#newfs -U /dev/stripe/test


# # # run 3
# geom stripe creation - stripe equal to hardware stripe width
# DID NOT RUN AGAIN #gstripe label -v -s 128k  test /dev/mfid0 /dev/mfid2
# soft updates, rest are defaults.  No journal.
# DID NOT RUN AGAIN #newfs -U /dev/stripe/test

# same filesystem as run 3 with /etc/fstab modified to mount async.  
# may not be relevant with a soft mount filesystem, but no docs really say
# the two seem mutually exclusive...let's try it.

#/etc/fstab used to mount /test (,async is the diff from last tests):
#/dev/stripe/test   /test   ufs     rw,async   2  2

# no results kept - tunefs -e 16384 /dev/stripe/test
# mounted with defaults
# did not do a newfs.  no journal, soft updates, see tunefs4.txt
# test cancelled, read performance clearly worse than before


# no results kept - default settings, reset maxbpg to 2048 default (tunefs -e)
# default /etc/fstab settings
# did tunefs to remove softupdates and enable journaling before mounting
#
#tunefs -J enable -n disable /dev/stripe/test
# slightly better write and read performance in dd test, but read
# performance still unacceptable



####
#
# dd used from this point to determine if read problem fixed in any config
# time dd if=/dev/zero of=/test/deletafile bs=1M count=10240
# time dd if=/test/deletafile of=/dev/null
#
####




# using 64k stripe width but still with soft mounts. 
# default newfs - do not think this is the problem with 
# reading though may need to tune newfs for large filesystem later

#gstripe label -v -s 64k test /dev/mfid0 /dev/mfid2
#newfs -U /dev/stripe/test

#  dd slightly faster, 24S to write 10G and 184S to read...not worth 
#  further tests


# using 32k stripe, same as above
#gstripe label -v -s 32k test /dev/mfid0 /dev/mfid2
#newfs -U /dev/stripe/test
#write: 23s 447929234 bps
#read: 171s 62683392 bps


# using 4k stripe, same as above
#gstripe label -v -s 4k test /dev/mfid0 /dev/mfid2
#newfs -U /dev/stripe/test

#write: 26.5s 403665800 bps 
#read: 157s 68343843 bps

# using 512k stripe, same as above
#gstripe label -v -s 512k test /dev/mfid0 /dev/mfid2
#newfs -U /dev/stripe/test

#write:  22.666453 secs (473714096 bytes/sec) 
#read: 190.390223 secs (56396899 bytes/sec)

# using 128k stripe, same as above (for reference, have iozone data)
#gstripe label -v -s 128k test /dev/mfid0 /dev/mfid2
#newfs -U /dev/stripe/test

#write:   22.814068 secs (470648996 bytes/sec)
#read:   188.360129 secs (57004730 bytes/sec)


# using 512byte stripe, same as above 
#gstripe label -v -s 512 test /dev/mfid0 /dev/mfid2
#newfs -U /dev/stripe/test

#write:  143.712598 secs (74714523 bytes/sec)  
#read:   157.643925 secs (68111843 bytes/sec)

# using 128k with ara enabled                                  
#gstripe label -v -s 128k test /dev/mfid0 /dev/mfid2
#newfs -U /dev/stripe/test

#write: 27.048787 secs (396964869 bytes/sec)
#read:   189.044960 secs (56798225 bytes/sec)

# using 128k without ara, with ra enabled
# kernel recompiled with "option SCHED_ULE"
#gstripe label -v -s 128k test /dev/mfid0 /dev/mfid2
#newfs -U /dev/stripe/test

#write:   27.011354 secs (397514995 bytes/sec)
#read:   191.525286 secs (56062667 bytes/sec)


#------- no softraid/gstripe -----------

# using 128k without ara, with ra enabled
# kernel recompiled with "option SCHED_ULE"
# no gstripe

#newfs -U /dev/mfid0

#write:  39.222672 secs (273755400 bytes/sec) 
#read:   144.597684 secs (74257194 bytes/sec)


#  mfid2 below must be the one in the 8x slot? 
#newfs -U /dev/mfid2

#write:  33.232960 secs (323095452 bytes/sec)
#read:    143.064971 secs (75052741 bytes/sec)

# ------------------------------


# using 128k without ara, with ra enabled
# kernel still recompiled with "option SCHED_ULE"
# blocksize problem?  I think not, if ZFS was the same
# quick test with 4096 for reference says 16k default was fine

#gstripe label -v -s 128k test /dev/mfid0 /dev/mfid2
#newfs -U -b 4096 /dev/stripe/test       

#write:     151.481005 secs (70882935 bytes/sec)
#read:    398.696164 secs (26931331 bytes/sec)


# using 128k without ara, with ra enabled
# kernel still recompiled with "option SCHED_ULE"

#gstripe label -v -s 128k test /dev/mfid0 /dev/mfid2
#newfs -U -b 65536 /dev/stripe/test

#write:  19.240875 secs (558052492 bytes/sec)     
#read:    48.096348 secs (223248098 bytes/sec)
# with  bs=1M count=10240 on dd read 
#read:  20.000606 secs (536854644 bytes/sec)

# using 128k without ara, with ra enabled
# kernel still recompiled with "option SCHED_ULE"

#gstripe label -v -s 64k test /dev/mfid0 /dev/mfid2
#newfs -U -b 65536 /dev/stripe/test

#write:   19.271309 secs (557171197 bytes/sec)
# with  bs=1M count=10240 on dd read, so watch comparisons to other 
# numbers in this file before this point (see above, maybe 100MB/s 
# different but not enough to account for disparities in other tests)

#read:   20.370359 secs (527109918 bytes/sec)


#  just to document that the bs param does not account for differences 
# earlier, rerun of some tests
#time dd if=/dev/zero of=/test/deletafile bs=1M count=10240
#time dd if=/test/deletafile of=/dev/null bs=1M count=10240

#gstripe label -v -s 32k test /dev/mfid0 /dev/mfid2
#newfs -U /dev/stripe/test
#oldwrite: 23s 447929234 bps
#write:  28.505461 secs (376679340 bytes/sec
#oldread: 171s 62683392 bps
#read:   138.755849 secs (77383536 bytes/sec)

#  quick zfs test is in /root/testing/zfs_...

# using 4k stripe, same as above
#gstripe label -v -s 4k test /dev/mfid0 /dev/mfid2
#newfs -U /dev/stripe/test
#oldwrite: 26.5s 403665800 bps
#oldread: 157s 68343843 bps

# using 128k stripe, same as above (for reference, have iozone data)
#gstripe label -v -s 128k test /dev/mfid0 /dev/mfid2
#newfs -U /dev/stripe/test

#oldwrite:   22.814068 secs (470648996 bytes/sec)
#write: 26.473629 secs (405589209 bytes/sec) 
#oldread:   188.360129 secs (57004730 bytes/sec)
#read: 157.700367 secs (68087465 bytes/sec)

## ---------- more iozone now -------------

# iozone run 4
# using 128k stripe, same as above 
#gstripe label -v -s 128k test /dev/mfid0 /dev/mfid2
#newfs -U -b 65536 /dev/stripe/test
#tunefs -p /dev/stripe/test



# 
# soft mounts off, journal on, async mount
#gstripe label -v -s 128k test /dev/mfid0 /dev/mfid2
#gjournal label -v /dev/stripe/test
#newfs -J -b 65536 /dev/stripe/test.journal
#tunefs -p /dev/stripe/test
#
# same read, slowed write

#time dd if=/dev/zero of=/test/deletafile bs=1M count=10240
#10240+0 records in
#10240+0 records out
#10737418240 bytes transferred in 52.802972 secs (203348748 bytes/sec)
#0.007u 23.147s 0:52.80 43.8%    26+174k 21+81939io 0pf+0w
#time dd if=/test/deletafile of=/dev/null bs=1M count=10240
#10240+0 records in
#10240+0 records out
#10737418240 bytes transferred in 20.570117 secs (521991112 bytes/sec)
#0.007u 9.863s 0:20.57 47.9%     26+173k 81946+0io 4pf+0w

#
#
#
######   HW stripe with now changed to 64k ###############################


#  now testing hardware stripe width + gstripe width, keeping fs blocksize at 65536
#
#
#  holding all else constant, but with 64k HW stripe       
#
#
#gstripe label -v -s 128k test /dev/mfid0 /dev/mfid2 
#newfs -U -b 65536 /dev/stripe/test
#mount /dev/stripe/test /test

#  now changing the gstripe to match hw stripe

#gstripe label -v -s 128k test /dev/mfid0 /dev/mfid2
#newfs -U -b 65536 /dev/stripe/test
#mount /dev/stripe/test /test


# redoing 4 with full system memory, 2008-05-22
# ----------------------------------------------------------------
# iozone run 5, same as 4 but with full system memory enabled
# using 128k stripe, same as above
#gstripe label -v -s 128k test /dev/mfid0 /dev/mfid2
#newfs -U -b 65536 /dev/stripe/test
#tunefs -p /dev/stripe/test
##
## Background init was ongoing during run 5, keeping results
##


# but doing it again
#

